/**==========================================================================
Hochschule Luzern - Technik & Architektur            Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                              http://hslu.ximit.ch
-----------------------------------------------------------------------------
Name        : Uebung_2-1.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-09-23v1.0
Description : Reverse
              Schreiben Sie eine Funktion reverse(s),
			  die die Zeichenkette s zeilenweise umkehrt.
===========================================================================*/

#include <stdio.h>
#include <stdlib.h>



/**
* Liest eine Zeile von maximal limit Zeichen ein.
* Die Zeichen werden (inklusive Zeilenende-Zeichen) im bergebenen * Vektor s /0 terminiert abgelegt.
* @param s Zeiger auf den Vektor zum Speichern der Eingabe
* @param limit Maximale Grsse des Vektors
* @return Anzahl eingelesene Zeichen
*/
int readLine(char s[], int limit);

/**
* Kehrt den Input Stream um speichert ihn in out.
* @param in String Input
* @param out Input String Reverse
*/
void reverseString(char in[], char out[], int len);


/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	
	char stringInput[100], stringReverse[100];
	int readCount;

	// Read Input String
	readCount = readLine(stringInput, 100);
	printf("Anz. Zeichen: %d\nInput:  %s", readCount, stringInput);
	//Reverse String
	reverseString(stringInput, stringReverse, readCount-1);
	//Output
	printf("Output: %s\n", stringReverse);




	

	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}


int readLine(char s[], int limit)
{
	int i = 0;
	int c;
	c = getchar();			/* Buchstabe einlesen */
	while((c != EOF) &&		/* Ende File ... */
          (c != '\n') &&	/* oder Ende Zeile ... */
		  (i < limit - 1))	/* oder Limite des Speichers? */
	{
		s[i] = c;
		i++;
		c = getchar();
	}
	if (c == '\n')
	{
		s[i] = '\n';		/* Zeilenumbruch anfgen! */
		i++;
	}
	s[i] = '\0';			/* Zeichenkette-Ende anfgen! */
	return i;				/* Anzahl gelesene Zeichen zurckgeben */
}

void reverseString(char in[], char out[], int len)
{
	int i = 0;
	for (; i<len; i++)
	{
		out[i] = in[len-i-1];
	}
	out[i] = '\0';
}
