/**==========================================================================
Hochschule Luzern - Technik & Architektur            Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                              http://hslu.ximit.ch
-----------------------------------------------------------------------------
Name        : Uebung_2-2.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-09-23v1.0
Description : Integer to String
              Schreiben Sie eine Funktion char* itoa(int i), welche die
			  bergebene Integerzahl in dezimaler Darstellung als
			  Zeichenkette zurck gibt.
===========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

/**
 * Berechnet die Anzahl stellen einer Zahl
 * @param number Zahl von der die anzahl Stellen gesucht sind
 * @return Anzahl Stellen
 */
int getDigitCount(int number);

/**
 * Gibt die Zahl als String zurck
 * @param i Zahl als Integer
 * @return Zahl als String
 */
char* itoa(int i);

/**
 * Kehrt den Input Stream um speichert ihn in out.
 * @param in String Input
 * @return String Reverse
 */
char* reverseString(char in[]);


/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	int wert;
	char *result;

	// Wert einlesen
	printf("Wert als Integer (auch negativ): ");
	scanf("%d", &wert);

	// Integer to ASCII
	result = itoa(wert);

	printf("Result: %s\n", result);

	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}

int getDigitCount(int number) {
    if(number != 0) {
        return (int)log10(abs(number)) + 1;
    } else {
        return 1;
    }
}

char* itoa(int i)
{
	int countDigit = 0;
	int pos = 0;
	int isPositive = 1;
	char *res;
	
	// Anzahl Stellen ermitteln
	countDigit = getDigitCount(i);
	// printf("GetDigitCount(%d): %d\n", i, countDigit);
	if (i < 0)
	{
		isPositive = 0;
		countDigit++;
		i = abs(i);
	}

	// Speicher fr String reservieren
	res = malloc(sizeof(char) * countDigit + 1);
	if (res)
	{
		while(i != 0)
		{
			res[pos] = (char) (i % 10 + 48); // + 48 fr ASCII Wert
			i /= 10;
			pos++;
		}
		if (!isPositive) 
		{
			res[pos] = '-';
			pos++;
		}
		res[pos] = '\0';
		res = reverseString(res);
	}
	else
	{
		printf("Error bei Speicherallokation...\n");
	}

	return res;
}

char* reverseString(char in[])
{
	int len = strlen(in);
	int i = 0;
	char tmp;
	for (; i<(len/2); i++)
	{
		tmp = in[i];
		in[i] = in[len-i-1];
		in[len-i-1] = tmp;
	}
	return in;
}
