/**==========================================================================
Hochschule Luzern - Technik & Architektur            Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                              http://hslu.ximit.ch
-----------------------------------------------------------------------------
Name        : Uebung_2-4.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-09-23v1.0
Description : Enum to String
===========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef enum Color_
{
	BLACK,  // Wert 0
	RED,    // Wert 1
	ORANGE, // Wert 2, usw
	YELLOW,
	GREEN,
	BLUE,
	VIOLET
} Color_t;

/**
 * Gibt den Namen einer Farbe zurck
 * @param color ENUM der Farbe
 * @return String mit dem Namen der Farbe
 */
char* getColorName(Color_t color);

/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
	// use return value
	char *colorName;
	colorName = getColorName(RED);
	printf("Color: %s\n", colorName);

	// pass direct to printf()
	printf("Color: %s\n", getColorName(YELLOW));

	// use Number insted of ENUM
	printf("Color: %s\n", getColorName(0));

	// unknow Color
	printf("Color: %s\n", getColorName(99));


	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}


/**
 * Gibt den Namen einer Farbe zurck
 * @param color ENUM der Farbe
 * @return String mit dem Namen der Farbe
 */
char* getColorName(Color_t color)
{
	const int COLORNAME_MAX_LEN = 10; // Max. 9 Zeichen fr den Namen + \0 !
	char* colorName = malloc(sizeof(char) * COLORNAME_MAX_LEN);
	if (colorName) // Memory allocation successfully
	{
		switch (color) {
		case BLACK:
			strcpy(colorName, "Black");
			break;
		case RED:
			strcpy(colorName, "Red");
			break;
		case ORANGE:
			strcpy(colorName, "Orange");
			break;
		case YELLOW:
			strcpy(colorName, "Yellow");
			break;
		case GREEN:
			strcpy(colorName, "Green");
			break;
		case BLUE:
			strcpy(colorName, "Blue");
			break;
		case VIOLET:
			strcpy(colorName, "Violet");
			break;
		default:
			strcpy(colorName, "UNKNOW");
			break;
		}
	}
	else
	{
		// Memory allocation failed!
		perror("Error allocate Memory!");
		exit(EXIT_FAILURE);
	}
	return colorName;
}

