/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : Uebung_2-6.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-09-23v1.0
Description : Fibonacci Zahlen
=================================================================================================*/


#include <stdio.h>
#include <stdlib.h>

/**
 * Berechnet die Fibonacci Zahlen.
 * Musterlsung von HSLU, Peter Sollberger
 * @author Peter Sollberger
 */
int main(int argc, char** argv)
{
	int number, i, count;
	int* fibonaccis;
	
	// Wert einlesen
	printf("Wieviele Fibonacci-Zahlen wollen Sie berechnen? ");
	scanf("%d", &number);
	printf("\n");
	
	count = number + 1;
	fibonaccis = malloc(sizeof (int) * count);
	if (fibonaccis)
	{
		// Calc Fibonacci-Zahlen
		fibonaccis[0] = 0;
		fibonaccis[1] = 1;
		for (i = 2; i < count; i++)
		{
			fibonaccis[i] = fibonaccis[i-1] + fibonaccis[i-2];
		}

		// Print
		printf("Die Fibonacci Zahlen von 0 bis %d lauten:\n", number);
		for (i = 0; i < count; i++)
		{
			printf("%d\n", fibonaccis[i]);
		}

		// Free Memory
		free(fibonaccis);
	}
	else
	{
		printf("Fehler in Speicherallokation\n");
	}
	
	fflush(stdin); //flushes the input stream and gets rid of '\n'
	printf("\n\nPress [Enter] to exit...");
	getchar();
	return(EXIT_SUCCESS);
}

